/*
 * menu_screen.hpp
 *
 * Copyright (c) Stephen Thompson, 2008.
 * Licensed for non-commercial use only. See LICENCE.txt for details.
 *
 */

#ifndef MENU_SCREEN_HPP
#define MENU_SCREEN_HPP

#include "app/app2d.hpp"
#include "knights_game.hpp"
#include "menu_selections.hpp"

#include <vector>
using namespace std;

void SetupMenuScreen(const UsefulStuff &u);
void StopMenuScreen(const UsefulStuff &u);

class MenuScreen : public AppObserver {
public:
    explicit MenuScreen(const UsefulStuff &u);
    virtual void render();
    virtual void update();
    virtual void mouseDown(int x, int y, bool rmb);
    virtual void windowResize(int new_width, int new_height);
private:
    void setupPages();
    void applyMenuConstraints();
    void backToTitle();
private:
    UsefulStuff us;
    int current_page;
    int lines_per_page;
    static MenuSelections menu_selections;  // keep these across different menu invocations...
    static bool first_time;
    vector<int> nlines;
    vector<int> pages;
};

#endif
